;-------------------------------------------------------------------------------
; Hogyan írjunk játékot ZX Spectrumra...
; 2. Fejezet - Billentyűzetes és botkormány irányítás
;-------------------------------------------------------------------------------
; Példaprogram 2.4 - Egy egyszerű játék
;-------------------------------------------------------------------------------
; Tegyük is meg a következő lépést, és az eddig tanultakat átültetve a gyakorlatba, 
; írjuk meg egy egyszerű játék fő irányító részét! Ez lesz az alapja egy Százlábú játéknak, 
; amit az elkövetkezendő néhány fejezet alatt fogunk fejleszteni. Még nincs birtokunkban 
; minden szükséges tudás egy ilyen játékprogram elkészítéséhez, de azért el tudjuk kezdeni 
; egy kis irányítási hurok megírásával, amely lehetővé teszi a játékos számára egy kis törzs 
; irányítását a képernyőn. Vigyázat! A program nem tartalmaz kilépési lehetőséget a BASIC-be, 
; ezért mindenképpen mentsük el a forrásszöveget futtatás előtt!
;-------------------------------------------------------------------------------
; SjAsmPlus v1.07rc verzióval fordítva
;-------------------------------------------------------------------------------

	DEVICE ZXSPECTRUM48

; ide fordítjuk a kódot (32768)
	.org $8000

; címke az sjasmplus számára a kódhossz számításához
start:

; Fekete képernyőt szeretnénk

	ld	a, 71		; fehér tinta (7) fekete papíron (0),
				; világosan (64)
	ld	(23693), a	; képernyő színek beállítása
	xor	a		; akkumulátor nullázásának gyors módja
	call	8859		; maradandó keretszín

; Grafika beállítása

	ld	hl, blocks	; felhasználói grafikus elemek címe
	ld	(23675), hl	; az UDG ide mutasson

; Rendben, kezdődjön a játék!

	call	3503		; ROM rutin – képernyő törlése, 
				;2-es csat. nyitása

; Koordináták inicializálása

	ld	hl, 21+15*256	; kezdeti koordináták a HL-be
	ld	(plx), hl	; játékos koordinátái

	call	basexy		; x és y pozíciójának beállítása
	call	splayr		; játékos törzsének megjelenítése

; Ez a főhurok

mloop	equ $

; Játékos törlése

	call	basexy		; x és y pozíciójának beállítása
	call	wspace		; üres hely a játékos pozíciójába

; Törölve van a játékos, átmozgathatjuk az új pozícióba mielőtt újra
; megjelenítjük

	ld	bc, 63486	; billentyűk 1-5/joystick port 2
	in	a, (c)		; kiolvassuk a megnyomott gombokat
	rra			; legkülső bit = 1-es gomb
	push	af		; megjegyezzük
	call	nc, mpl		; ha megnyomva, mozgás balra
	pop	af		; akku helyreállítása
	rra			; következő bit (2-es helyiérték)
				; = 2-es gomb
	push	af		; megjegyezzük
	call	nc, mpr		; ha megnyomva, mozgás jobbra
	pop	af		; akku helyreállítása
	rra 			; következő bit (4-es helyiérték)
				; = 3-es gomb
	push	af		; megjegyezzük
	call	nc, mpd		; ha megnyomva, mozgás lefelé
	pop	af		; akku helyreállítása
	rra 			; következő bit (8-es helyiérték)
				; = 4-es gomb
	call	nc, mpu		; ha megnyomva, mozgás felfelé

; Az átmozgatás megtörtént, újra megjeleníthetjük a játékost

	call	basexy		; x és y koordináta beállítása
	call	splayr		; játékos megjelenítése

	halt			; várakozás

; Visszaugrás a főhurok elejére

	jp	mloop

; Játékos balra mozgatása

mpl	ld	hl, ply		; Emlékezzünk, 
				; y a vízszintes koordináta!
	ld	a, (hl		; Mi a mostani érték?
	and	a		; Nulla?
	ret	z		; Ha igen, 
				; nem tudunk tovább balra menni!
	dec	(hl)		; különben y = y-1
	ret

; Játékos jobbra mozgatása.

mpr	ld	hl, ply		; Emlékezzünk, 
				; y a vízszintes koordináta!
	ld	a, (hl)		; Mi a mostani érték?
	cp	31		; A jobb szélén vagyunk (31)?
	ret	z		; Ha igen, 
				; nem tudunk tovább jobbra menni!
	inc	(hl)		; különben y = y+1
	ret

; Játékos felfelé mozgatása.

mpu	ld	hl, plx		; Emlékezzünk, 
				; x a függőleges koordináta!
	ld	a, (hl)		; Mi a mostani érték?
	cp	4		; a pálya tetején vagyunk (4)?
	ret	z		; Ha igen, 
				;nem tudunk tovább felfele menni!
	dec 	(hl)		; különben x = x-1
	ret

; Játékos lefelé mozgatása.

mpd	ld	hl, plx		; Emlékezzünk, 
				; x a függőleges koordináta!
	ld	a, (hl)		; Mi a mostani érték?
	cp	21		; A képernyő alján vagyunk (21)?
	ret	z		; Ha igen, 
				; nem tudunk tovább lefele menni!
	inc	(hl)		; különben x = x+1
	ret

; A játékos törzsének, x és y koordináta értékének beállítása,
; ez a rutin kerül meghívásra a törzs törlése és megjelenítése előtt

basexy	ld	a, 22		; AT pozícionáló kód.
	rst	16
	ld	a, (plx)	; játékos függőleges koord.
	rst	16		; beállítjuk
	ld	a, (ply)	; játékos vízszintes koord.
	rst	16		; ezt is beállítjuk
	ret

; Megjelenítjük a játékost a jelenlegi PRINT pozícióban

splayr	ld	a, 69		; cián tinta (5) fekete papíron (0),
				; világosan (64)
	ld	(23695), a	; beállítjuk az ideiglenes színeket
	ld	a, 144		; 'A' UDG ASCII kódja
	rst	16		; játékos kirajzolása
	ret

wspace	ld	a, 71		; fehér tinta (7) fekete papíron (0),
				; világos (64)
	ld	(23695), a	; beállítjuk az ideiglenes színeket
	ld	a, 32		; SZÓKÖZ karakter
	rst	16		; üres hely megjelenítése
	ret

plx	.db	0		; játékos x koordinátája
ply	.db	0		; játékos y koordinátája

; UDG grafika

blocks	.db	16,16,56,56,124,124,254,254	; játékos törzse

; címke az sjasmplus számára a kódhossz számításához
end:

; a lefordított bináris kódot elmenti
	.savebin "pelda_2_4.bin",start,end-start   
